import _extends from "@babel/runtime/helpers/esm/extends";
import { line } from 'd3-shape';
import React from 'react';
import { getX, getY, translate } from '../utils/Utils';
import useChartContext from '../utils/chartContext'; //

import { monotoneX } from '../utils/curveMonotone';
var pathDefaultStyle = {
  strokeWidth: 2
};
export default function Line(_ref) {
  var _secondaryAxis$curve;

  var primaryAxis = _ref.primaryAxis,
      secondaryAxis = _ref.secondaryAxis,
      allSeries = _ref.series;

  var _useChartContext = useChartContext(),
      getSeriesStatusStyle = _useChartContext.getSeriesStatusStyle,
      getDatumStatusStyle = _useChartContext.getDatumStatusStyle,
      focusedDatumState = _useChartContext.focusedDatumState,
      gridDimensions = _useChartContext.gridDimensions;

  var curve = (_secondaryAxis$curve = secondaryAxis.curve) != null ? _secondaryAxis$curve : monotoneX;
  var focusedDatum = focusedDatumState[0];
  return /*#__PURE__*/React.createElement("g", {
    style: {
      transform: translate(gridDimensions.left, gridDimensions.top)
    }
  }, allSeries.map(function (series, i) {
    var _line$curve;

    var style = getSeriesStatusStyle(series, focusedDatum);

    var lineStyle = _extends({}, pathDefaultStyle, style, style.line, {
      fill: 'none'
    });

    var linePath = (_line$curve = line(function (datum) {
      var _getX;

      return (_getX = getX(datum, primaryAxis, secondaryAxis)) != null ? _getX : NaN;
    }, function (datum) {
      var _getY;

      return (_getY = getY(datum, primaryAxis, secondaryAxis)) != null ? _getY : NaN;
    }).curve(curve)(series.datums)) != null ? _line$curve : undefined;
    return /*#__PURE__*/React.createElement("g", {
      key: "lines-" + i
    }, series.datums.map(function (datum, i) {
      var _secondaryAxis$showDa;

      var dataStyle = getDatumStatusStyle(datum, focusedDatum);
      return /*#__PURE__*/React.createElement("circle", {
        key: i,
        ref: function ref(el) {
          datum.element = el;
        },
        r: 2,
        cx: getX(datum, primaryAxis, secondaryAxis),
        cy: getY(datum, primaryAxis, secondaryAxis),
        stroke: "rgba(33,33,33,0.5)",
        fill: "transparent",
        style: _extends({
          // @ts-ignore
          r: 2
        }, style, style.circle, dataStyle, dataStyle.circle, !((_secondaryAxis$showDa = secondaryAxis.showDatumElements) != null ? _secondaryAxis$showDa : true) ? {
          opacity: 0
        } : {})
      });
    }), /*#__PURE__*/React.createElement("path", {
      d: linePath,
      style: lineStyle
    }));
  }));
}